Subject: Re: bug#24972: 26.0.50; Multibyte characters are misaligned in ibuffer

From: Mark Oteiza <[email-masked]>
Date: Mon, 21 Nov 2016 04:35:45 -0500

On 21/11/16 at 02:00pm, Liu Hui wrote:
> 在 2016年11月21日 02:58, Mark Oteiza 写道:
> > Liu Hui <[email-masked]> writes:
> > > As shown in the screenshot attached, multibyte characters (the second
> > > line) are misaligned in ibuffer. The problem seems at least relevant
> > > to the function `ibuffer-compile-format', which uses `length' rather
> > > than `string-width' for characters.
> > 
> > Indeed, changing to string-width improves it. ibuffer should probably
> > also be using display properties to align the columns, but that's
> > another issue.
> > 
> > Committed in 7e2a8b1. Thanks for reporting
> 
> Thank you, but I find it does not work when the multibyte string is long.
> For example, if the string-width of buffer name, e.g.
> "一个很长很长的文件名", exceeds the default width of ibuffer column, M-x
> ibuffer will fail and issue an error.
> 
> According to the backtrace, it is because `ibuffer-compile-format' calls
> `ibuffer-compile-make-substring-form'/`ibuffer-compile-make-eliding-form',
> which use `substring' to truncate the multibyte string. A similar issue was
> reported in https://github.com/emacs-helm/helm/issues/170. Probably
> replacing `substring' solves the problem.

Ah, thanks. I pushed another change that fixes the error.  Still, if the
name is a particular mix of half- and full-width though (e.g.
"aーーーーーー"), the next column(s) might be off by one.